VERSION 5.00
Begin VB.Form FFloodFill 
   Caption         =   "ExtFloodFill Demo"
   ClientHeight    =   5835
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7410
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5835
   ScaleWidth      =   7410
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Fill&Modes:"
      Height          =   615
      Left            =   180
      TabIndex        =   8
      Top             =   5100
      Width           =   4215
      Begin VB.OptionButton Option1 
         Caption         =   "FLOODFILLBORDER"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   1935
      End
      Begin VB.OptionButton Option1 
         Caption         =   "FLOODFILLSURFACE"
         Height          =   255
         Index           =   1
         Left            =   2100
         TabIndex        =   10
         Top             =   240
         Width           =   1935
      End
   End
   Begin VB.ComboBox Combo3 
      Height          =   315
      Left            =   5280
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   4680
      Width           =   1995
   End
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   3255
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   4680
      Width           =   1155
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   900
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   4680
      Width           =   1155
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Draw Shapes"
      Height          =   435
      Left            =   5280
      TabIndex        =   0
      Top             =   5220
      Width           =   1995
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   4395
      Left            =   120
      MousePointer    =   2  'Cross
      ScaleHeight     =   4335
      ScaleWidth      =   7095
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   120
      Width           =   7155
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "&Fill Style:"
      Height          =   195
      Left            =   4560
      TabIndex        =   6
      Top             =   4740
      Width           =   615
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "&Border Color:"
      Height          =   195
      Left            =   2250
      TabIndex        =   4
      Top             =   4740
      Width           =   915
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Fill &Color:"
      Height          =   195
      Left            =   165
      TabIndex        =   2
      Top             =   4740
      Width           =   630
   End
End
Attribute VB_Name = "FFloodFill"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 2001, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

' Member variables
Private m_X As Single
Private m_Y As Single
Private m_Painter As CFloodFill

Private Sub Combo1_Click()
   m_Painter.FillColor = Combo1.ItemData(Combo1.ListIndex)
End Sub

Private Sub Combo2_Click()
   Call SetBorderColor
End Sub

Private Sub Combo3_Click()
   m_Painter.FillStyle = Combo3.ItemData(Combo3.ListIndex)
End Sub

Private Sub Command1_Click()
   Call DrawShapes
End Sub

Private Sub Form_Load()
   Dim i As Long
   
   ' setup Painter object
   Set m_Painter = New CFloodFill
   Set m_Painter.Canvas = Picture1
   
   ' setup controls
   Call FillColorList(Combo1)
   Call FillColorList(Combo2)
   Call FillStyleList(Combo3)
   Option1(1).Value = True
   
   ' show and draw first shapes
   Set Me.Icon = Nothing
   Me.Show
   Call DrawShapes
   Combo1.ListIndex = 3
   Combo2.ListIndex = 0
   Combo3.ListIndex = 0
End Sub

Private Sub Option1_Click(Index As Integer)
   ' Fill flags match selected option index.
   m_Painter.FillMode = Index
   Call SetBorderColor
End Sub

Private Sub Picture1_Click()
   ' Update border color, if doing
   ' a surface fill
   If m_Painter.FillMode = FLOODFILLSURFACE Then
      m_Painter.BorderColor = Picture1.Point(m_X, m_Y)
   End If
   ' Paint using cached coordinates
   m_Painter.Paint m_X, m_Y
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   ' Cache mousedown coordinates
   m_X = X
   m_Y = Y
End Sub

' **********************************************
'  Private Methods
' **********************************************
Private Sub DrawShapes()
   Dim i As Long
   Dim x1 As Long, y1 As Long
   Dim x2 As Long, y2 As Long
   Dim c As Long
   
   Randomize Timer
   With Picture1
      .Cls
      For i = 1 To 20
         x1 = Rnd * .ScaleWidth
         y1 = Rnd * .ScaleHeight
         x2 = Rnd * .ScaleWidth
         y2 = Rnd * .ScaleHeight
         c = Combo1.ItemData(Rnd * 7)
         If i Mod 2 Then
            Picture1.Line (x1, y1)-(x2, y2), c, B
         Else
            Picture1.Circle (x1, y1), y2, c
         End If
      Next i
   End With
End Sub

Private Sub FillColorList(ByVal cbo As ComboBox)
   ' setup dropdown color lists
   With cbo
      .AddItem "vbBlack"
      .ItemData(.NewIndex) = vbBlack
      .AddItem "vbBlue"
      .ItemData(.NewIndex) = vbBlue
      .AddItem "vbCyan"
      .ItemData(.NewIndex) = vbCyan
      .AddItem "vbGreen"
      .ItemData(.NewIndex) = vbGreen
      .AddItem "vbMagenta"
      .ItemData(.NewIndex) = vbMagenta
      .AddItem "vbRed"
      .ItemData(.NewIndex) = vbRed
      .AddItem "vbWhite"
      .ItemData(.NewIndex) = vbWhite
      .AddItem "vbYellow"
      .ItemData(.NewIndex) = vbYellow
   End With
End Sub

Private Sub FillStyleList(ByVal cbo As ComboBox)
   ' setup dropdown style lists
   With cbo
      .AddItem "vbFSSolid"
      .ItemData(.NewIndex) = vbFSSolid
      .AddItem "vbFSTransparent"
      .ItemData(.NewIndex) = vbFSTransparent
      .AddItem "vbHorizontalLine"
      .ItemData(.NewIndex) = vbHorizontalLine
      .AddItem "vbVerticalLine"
      .ItemData(.NewIndex) = vbVerticalLine
      .AddItem "vbUpwardDiagonal"
      .ItemData(.NewIndex) = vbUpwardDiagonal
      .AddItem "vbDownwardDiagonal"
      .ItemData(.NewIndex) = vbDownwardDiagonal
      .AddItem "vbCross"
      .ItemData(.NewIndex) = vbCross
      .AddItem "vbDiagonalCross"
      .ItemData(.NewIndex) = vbDiagonalCross
   End With
End Sub

Private Sub SetBorderColor()
   Select Case m_Painter.FillMode
      Case FLOODFILLBORDER
         m_Painter.BorderColor = Combo2.ItemData(Combo2.ListIndex)
      Case FLOODFILLSURFACE
         m_Painter.BorderColor = Picture1.BackColor
   End Select
End Sub
